> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/aave-v3/umbrellastake.md).

# UmbrellaStake

### Description

UmbrellaStake - Stake aTokens/underlying or GHO tokens using Umbrella Stake Token

> **Notes**
>
> This action will always pull aTokens or underlying for non GHO staking and wrap them into waTokens for staking. Wraps aTokens into waTokens. Wraps underlying asset into waTokens.

### Action ID

`0x1c4fe1da`

### SDK Action

```ts
const umbrellaStakeAction = new dfs.actions.umbrella.UmbrellaStakeAction(
    stkToken,
    from.address,
    to.address,
    amount,
    useATokens,
    minSharesOut
);

```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param stkToken The umbrella stake token.
    /// @param from The address from which the aToken or GHO will be pulled.
    /// @param to The address to which the stkToken will be transferred
    /// @param amount The amount of aToken/underlying or GHO to be staked.
    /// @param useATokens Whether to use aTokens or underlying for staking (e.g. aUSDC or USDC).
    /// @param minSharesOut The minimum amount of stkToken shares to receive.
    struct Params {
        address stkToken;
        address from;
        address to;
        uint256 amount;
        bool useATokens;
        uint256 minSharesOut;
    }
```

### Return Value

```solidity
return bytes32(stkTokenShares);
```

### Events and Logs

```solidity
emit ActionEvent("UmbrellaStake", logData);
logger.logActionDirectEvent("UmbrellaStake", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/aave-v3/umbrellastake.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
